<template>
  <div>
    <v-card class="pa-9">
      <v-tabs v-model="curTestStep" class="test-tabs">
        <v-tab-item>
          <div class="headline">Название теста: {{ baseInfo.name }}</div>
          <div class="headline">Автор: {{ baseInfo.author.name }}</div>
          <div style="max-width: 200px">
            <ValidationObserver tag="form" ref="observer">
              <ValidationProvider
                name="group"
                v-slot="{ errors }"
                rules="required"
              >
                <v-select
                  v-model="group"
                  width="200"
                  :error-messages="errors"
                  :items="baseInfo.groups"
                ></v-select>
              </ValidationProvider>
            </ValidationObserver>
          </div>
          <div class="headline">
            Статус: {{ Test.getTestStatusByCode(baseInfo.status) }}
          </div>
          <v-btn @click="startHandle" color="success">Поехали!</v-btn>
        </v-tab-item>
        <v-tab-item>
          <div class="question-tester-tab">
            Вопрос {{ curQuestionNumber + 1 }} из {{ baseInfo.number }}
            <div class="d-flex flex-grow-1">
              <QuestionTester
                v-bind="{ question, curQuestionNumber }"
                @send-answer="onSendAnswer"
              />
            </div>
          </div>
        </v-tab-item>
        <v-tab-item>
          <div class="d-flex flex-column">
            <div class="headline">Вы прошли тест!</div>
            <v-btn color="purple" width="220" to="/results"
              >Посмотреть результат</v-btn
            >
          </div>
        </v-tab-item>
      </v-tabs>
    </v-card>
  </div>
</template>
<script>
import Test from "@/classes/Test";
import QuestionTester from "@/components/Question/QuestionTester";
import Validatable from "@/mixins/Validatable";
export default {
  components: {
    QuestionTester
  },
  mixins: [Validatable],
  props: {
    baseInfo: {
      type: Object,
      default: () => {}
    },
    question: {
      type: Object,
      default: () => {}
    },
    testStatus: {
      type: String,
      default: () => "new"
    },
    curQuestionNumber: {
      type: Number
    }
  },
  data() {
    return {
      Test,
      group: [],
    };
  },
  computed: {
    curTestStep() {
      switch (this.testStatus) {
        case "new":
          return 0;
          break;
        case "in_progress":
          return 1;
          break;
        case "finished":
          return 2;
          break;
        default:
          return 0;
          break;
      }
    }
  },
  methods: {
    async startHandle() {
      const isValid = await this.$refs.observer.validate();
      if (isValid) {
        this.$emit("start", { group: this.group });
      }
    },
    onSendAnswer(e) {
      this.$emit("send-answer", { ...e, resultId: this.baseInfo.resultId });
    }
  }
};
</script>
<style lang="scss">
.test-tabs {
  .v-tabs-bar {
    display: none;
  }
}
.question-tester-tab {
  display: grid;
  grid-template-columns: 300px 1fr;
  grid-gap: 20px;
  &__list {
    min-width: 300px;
  }
}
</style>